setup-timezone.in 2.01 KB
Newer Older
1 2 3 4 5 6
#!/bin/sh

PREFIX=
. "$PREFIX/lib/libalpine.sh"


Natanael Copa's avatar
Natanael Copa committed
7
zroot=/usr/share/zoneinfo
8

9 10
usage() {
        cat <<__EOF__
11
usage: setup-timezone [-h] [-z subdir of $zroot]
12 13 14 15 16

Sets the timezone for the system.

options:
 -h  Show this help
17
 -z  Specify the timezone as a subdirectory of $zroot
18 19 20 21
__EOF__
        exit 1
}

Natanael Copa's avatar
Natanael Copa committed
22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44
show_tz_list() {
	local i z= list=
	local path="$zroot/$1"
	[ -d "$path" ] || return 1

	for i in $(find $path -maxdepth 1); do
		case $i in
		*.tab|*/) continue;;
		esac
		if [ -d "$i" ]; then
			z="$z ${i##*/}/"
		else
			z="$z ${i##*/}"
		fi
	done
	( cd $path && ls --color=never -Cd $z )
}

valid_tz() {
	find $zroot -type f -a -not -name '*.tab' -a -not -name 'Factory' \
		| xargs posixtz | sort | uniq | grep -q -w "$1"
}

45
while getopts "hz:" opt; do
46 47
        case $opt in
                h) usage;;
48
		z) ZONEINFODIR="$OPTARG";;
49 50 51
        esac
done

52 53
if ! apk info --quiet --installed tzdata; then
	apk add --quiet tzdata && apkdel="tzdata" || exit 1
Natanael Copa's avatar
Natanael Copa committed
54 55 56 57 58 59
fi

zonepath=$(cat /etc/TZ 2>/dev/null)
[ -z "$zonepath" ] && zonepath="UTC"

while true; do
60 61
	if [ -n "$ZONEINFODIR" ]; then
		TZ=$(posixtz "$ZONEINFODIR") || echo "Failed to convert '$ZONEINFODIR' to POSIX TZ"
62 63 64 65 66 67
		if [ -n "$TZ" ]; then
			echo $TZ > /etc/TZ || rm -f /etc/TZ
		fi
		break
	fi

68
	echo -n "Which timezone are you in? ('?' for list) [$zonepath] "
Natanael Copa's avatar
Natanael Copa committed
69 70 71 72
	default_read zonepath "$zonepath"
	case "$zonepath" in
	"") continue;;
	"?") show_tz_list; continue;;
73
	esac
Natanael Copa's avatar
Natanael Copa committed
74 75

	while [ -d "$zroot/$zonepath" ]; do
Yves Schumann's avatar
Yves Schumann committed
76 77
		zone=
		echo -n "What sub-timezone of '$zonepath' are you in? ('?' for list) "
Natanael Copa's avatar
Natanael Copa committed
78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96
		default_read zone
		case "$zone" in
		"?") show_tz_list "$zonepath"; continue;;
		esac
		zonepath="$zonepath/$zone"
	done

	TZ=
	if valid_tz "$zonepath"; then
		TZ="$zonepath"
	elif [ -f "$zroot/$zonepath" ]; then
		TZ=$(posixtz "$zroot/$zonepath") \
			|| echo "Failed to convert '$zroot/$zonepath' to POSIX TZ"
	fi

	if [ -n "$TZ" ]; then
		echo $TZ > /etc/TZ || rm -f /etc/TZ
		break
	fi
97
	echo "'$zonepath' is not a valid timezone on this system"
Natanael Copa's avatar
Natanael Copa committed
98 99 100
done

if [ -n "$apkdel" ]; then
101
	apk del --quiet $apkdel
102 103
fi